package org.example;

import java.time.LocalDate;
import java.time.temporal.TemporalAdjusters;
import java.util.Calendar;

// Press Shift twice to open the Search Everywhere dialog and type `show whitespaces`,
// then press Enter. You can now see whitespace characters in your code.
public class Main {
    public static void main(String[] args) {
        // Get the current date
        Calendar calendar = Calendar.getInstance();

        // Set the date to the first day of the next month
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        calendar.add(Calendar.MONTH, 1);

        // Subtract one day to get the last day of the current month
        calendar.add(Calendar.DAY_OF_MONTH, -1);

        // Get the last day of the month
        int lastDay = calendar.get(Calendar.DAY_OF_MONTH);

        System.out.println("Last day of the current month: " + lastDay);

        // Specify the desired month and year
        int year = 2023;
        int month = Calendar.JULY; // Calendar.JULY corresponds to July (0-based index)

        // Get the last day of the specified month and year
        int lastDay1 = getLastDayOfMonth(year, month);

        System.out.println("Last day of July 2023: " + lastDay1);

        // Get the current date
        LocalDate currentDate = LocalDate.now();

        // Get the last day of the current month
        int lastDay2 = currentDate.lengthOfMonth();

        System.out.println("Last day of the current month: " + lastDay2);

        // Get the current date
        LocalDate currentDate1 = LocalDate.now();

        // Get the last day of the current month
        LocalDate lastDay3 = currentDate1.with(TemporalAdjusters.lastDayOfMonth());

        System.out.println("Last day of the current month: " + lastDay3.getDayOfMonth());


    }

    private static int getLastDayOfMonth(int year, int month) {
        // Get the last day of the specified month and year
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.YEAR, year);
        calendar.set(Calendar.MONTH, month);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        calendar.add(Calendar.MONTH, 1);
        calendar.add(Calendar.DAY_OF_MONTH, -1);
        return calendar.get(Calendar.DAY_OF_MONTH);
    }


}